//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "SysUtils.hpp"
#include "PowerArc.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  for (int j=0; j < PowerArcModules.Length; j++)
    ArcComboBox->Items->Add(PowerArcModules[j].Info->Name);
  ArcComboBox->ItemIndex=0;
  ArcComboBoxChange(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ArcComboBoxChange(TObject *Sender)
{
  if (ArcComboBox->ItemIndex >= 0) {
    AboutLabel->Caption=PowerArcModules[ArcComboBox->ItemIndex].Info->Description;
    OptComboBox->Items=PowerArcModules[ArcComboBox->ItemIndex].Options;
    OptComboBox->Items->Insert(0,"Default");
    OptComboBox->ItemIndex=0;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FileListBox1Change(TObject *Sender)
{
  Button1->Enabled=FileExists(FileListBox1->FileName) &&
    (AnsiCompareText(ExtractFileExt(FileListBox1->FileName),".pk") != 0);
  Button2->Enabled=FileExists(FileListBox1->FileName) &&
    (AnsiCompareText(ExtractFileExt(FileListBox1->FileName),".pk") == 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  TFileStream *InStream,*OutStream;
  AnsiString Opt;
  if (ArcComboBox->ItemIndex >= 0) {
    InStream=new TFileStream(FileListBox1->FileName,fmOpenRead);
    OutStream=new TFileStream(FileListBox1->FileName+".pk",fmCreate);
    if (OptComboBox->ItemIndex <= 0) Opt="";
    else Opt=OptComboBox->Items->Strings[OptComboBox->ItemIndex];
    if (StreamCheck->Checked) {
      TPowerArcCompressStream *CompressStream;
      CompressStream=new TPowerArcCompressStream(OutStream,ArcComboBox->ItemIndex,Opt);
      CompressStream->CopyFrom(InStream,0);
      delete CompressStream;
    } else {
      Compress(ArcComboBox->ItemIndex,InStream,OutStream,Opt);
    }
    LogMemo->Lines->Add("Compress "+FileListBox1->FileName);
    LogMemo->Lines->Add("Size\9"+IntToStr(InStream->Size));
    LogMemo->Lines->Add("Destination "+FileListBox1->FileName+".pk");
    LogMemo->Lines->Add("Size\9"+IntToStr(OutStream->Size));
    LogMemo->Lines->Add("Ratio\9"+FormatFloat("#0.00",OutStream->Size*100.0/InStream->Size)+"%");
    LogMemo->Lines->Add("BPC\9"+FormatFloat("#0.000",OutStream->Size*8.0/InStream->Size));
    LogMemo->Lines->Add("");
    delete InStream;
    delete OutStream;
    FileListBox1->Update();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  TFileStream *InStream,*OutStream;
  InStream=new TFileStream(FileListBox1->FileName,fmOpenRead);
  OutStream=new TFileStream(ChangeFileExt(FileListBox1->FileName,".org"),fmCreate);
  if (StreamCheck->Checked) {
    TPowerArcDecompressStream *DecompressStream;
    char Buff[4096];
    int len;
    DecompressStream=new TPowerArcDecompressStream(InStream);
    len=DecompressStream->Read(Buff,4096);
    while (len > 0) {
      OutStream->Write(Buff,len);
      len=DecompressStream->Read(Buff,4096);
    }
    delete DecompressStream;
  } else {
    Decompress(InStream,OutStream);
  }
  LogMemo->Lines->Add("Decompress "+FileListBox1->FileName);
  LogMemo->Lines->Add("");
  delete InStream;
  delete OutStream;
  FileListBox1->Update();
}
//---------------------------------------------------------------------------
